//
//  DelayNode.hpp
//  SwitchboardAudioEffects
//
//  Created by Balazs Kiss on 2022. 10. 13..
//

#pragma once

#include <switchboard_core/SingleBusAudioProcessorNode.hpp>

namespace switchboard::extensions::audioeffects {

class DelayNode : public SingleBusAudioProcessorNode {
public:
    SB_WASM_EXPORT(DelayNode)

    SB_WASM DelayNode(const uint maxNumberOfChannels = constants::STEREO);
    SB_WASM virtual ~DelayNode();

    SB_WASM bool getIsEnabled();
    SB_WASM void setIsEnabled(bool newValue);

    SB_WASM float getDryMix();
    SB_WASM void setDryMix(float newValue);

    SB_WASM float getWetMix();
    SB_WASM void setWetMix(float newValue);

    SB_WASM uint getDelayMs();
    SB_WASM void setDelayMs(uint newValue);

    SB_WASM float getFeedbackLevel();
    SB_WASM void setFeedbackLevel(float newValue);

    // MARK: Overridden methods

    SB_WASM bool setBusFormat(AudioBusFormat& inputBusFormat, AudioBusFormat& outputBusFormat) override;
    SB_WASM bool process(AudioBus& inBus, AudioBus& outBus) override;

private:
    class Internals;
    std::unique_ptr<Internals> internals;
};

}
