//
//  FlangerNode.hpp
//  SwitchboardAudioEffects
//
//  Created by Balázs Kiss on 2022. 10. 30..
//

#pragma once

#include <switchboard_core/SingleBusAudioProcessorNode.hpp>

namespace switchboard::extensions::audioeffects {

class FlangerNode : public SingleBusAudioProcessorNode {
public:
    SB_WASM_EXPORT(FlangerNode)

    SB_WASM FlangerNode(const uint maxNumberOfChannels = constants::STEREO);
    SB_WASM virtual ~FlangerNode();

    SB_WASM bool getIsEnabled();
    SB_WASM void setIsEnabled(bool newValue);

    SB_WASM float getSweepWidth();
    SB_WASM void setSweepWidth(const float newValue);

    SB_WASM float getFrequency();
    SB_WASM void setFrequency(const float newValue);

    // MARK: Overridden methods

    SB_WASM bool setBusFormat(AudioBusFormat& inputBusFormat, AudioBusFormat& outputBusFormat) override;
    SB_WASM bool process(AudioBus& inBus, AudioBus& outBus) override;

private:
    class Internals;
    std::unique_ptr<Internals> internals;
};

}
